#include "mutex"
#include "error/error"
#include "profiler/profiler"

void Mutex::unlock(void *target) {
    PROFILE("Mutex::unlock");
    
    if (int res = pthread_mutex_unlock(&s_lock[target]))
        throw static_cast<Error>("Failed to release mutex lock: ") +
	strerror(res);
}
