#include "config"

void Config::setbackend (string str, string host) {
    vector<string> parts = str2parts (str, ':');
    if (parts.size() < 2 || parts.size() > 4)
	throw static_cast<Error>("Bad back end specifier in '-b") + str +
	    "', expected: SERVER:PORT or SERVER:PORT:MAXCONNECTIONS or "
	    "SERVER:PORT:MAXCONNECTIONS:WEIGHT";

    BackendDef *bdp = 0;
    if (parts.size() == 2)
	bdp = new BackendDef(parts[0], parts[1]);
    else if (parts.size() == 3)
	bdp = new BackendDef(parts[0], parts[1], parts[2]);
    else if (parts.size() == 4)
	bdp = new BackendDef(parts[0], parts[1], parts[2], parts[3]);
    bdp->hostmatch(host);
    blist.push_back (*bdp);
    delete bdp;
}
