#include "netbuffer"

void Netbuffer::check_space(unsigned extra) {
    PROFILE("Netbuffer::check_space");

    if (!buf_alloced) {
	buf_alloced = extra;
	buf_data = (char*)malloc(buf_alloced);
	if (! buf_data)
	    throw static_cast<Error>("Memory fault in Netbuffer::check_space");
    } else if (buf_sz + extra > buf_alloced) {
	msg((Mstr("Reallocating net buffer from ") + buf_alloced) +
	    (Mstr(" to ") + (buf_alloced + extra)) + " bytes\n");
	buf_alloced += extra;
	buf_data = (char*)realloc(buf_data, buf_alloced);
	if (! buf_data)
	    throw static_cast<Error>("Memory fault in Netbuffer::check_space");
    }
}
