#include "netbuffer"

unsigned Netbuffer::netread (int fd, int timeout) {    
    PROFILE("Netbuffer::netread");

    if (timeout) {
	Fdset set(timeout);
	set.add(fd);
	if (set.readable() != fd)
	    throw static_cast<Error>("Fd ") + fd +
		" failed to become readable within " + timeout + "sec";
    }
    
    check_space(config.buffersize());
    
    ssize_t nread = read (fd, buf_data + buf_sz, config.buffersize());
    if (nread < 0)
	throw static_cast<Error>("Read failed on fd ") + fd;
    buf_sz += nread;

    if (config.debug() && nread) {
        ostringstream o;
        o << "Got " << nread << " bytes from fd " << fd << ": ";
        for (unsigned i = 0; i < (unsigned)nread; i++)
            o << printable(buf_data[i]);
        o << "\n";
        _debugmsg (o.str());
    }
    
    return nread;
}
