#include "tcpdispatcher"

TcpDispatcher::TcpDispatcher(int cfd, struct in_addr cip):
    Thread(), client_ip(cip), target_backend(-1), client_fd(cfd),
    backend_fd(-1), target_list(), netbuffer() {

    // Instantiate dispatchmode algorithm
    switch (config.dispatchmode()) {
    case Dispatchmode::m_roundrobin:
	algorithm = new Roundrobin;
	break;
    case Dispatchmode::m_firstactive:
	algorithm = new Firstactive;
	break;
    case Dispatchmode::m_external:
	algorithm = new External;
	break;
    case Dispatchmode::m_strict_hashed_ip:
    case Dispatchmode::m_lax_hashed_ip:
	algorithm = new HashedIp;
	break;
    case Dispatchmode::m_strict_stored_ip:
    case Dispatchmode::m_lax_stored_ip:
	algorithm = new StoredIp;
	break;
    case Dispatchmode::m_weighted_load:
	algorithm = new Weightedload;
	break;
    case Dispatchmode::m_leastconn:
    default:
	algorithm = new Leastconn;
	break;
    }
}
